﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;
using System.Diagnostics;

namespace esl
{
    class ChangeSignerRest
    {
        public static void main()
        {
            string jsonString = "{\"documents\":[{\"approvals\":[{\"id\":\"ExampleSignatureId\",\"role\":\"Signer1\",\"fields\":[{\"page\":0,\"top\":200,\"subtype\":\"LABEL\",\"height\":50,\"left\":100,\"width\":200,\"id\":\"myLabelField\",\"type\":\"INPUT\",\"value\":\"Example label field value\"},{\"page\":0,\"top\":100,\"subtype\":\"FULLNAME\",\"height\":50,\"left\":100,\"width\":200,\"type\":\"SIGNATURE\",\"name\":\"ExampleSignatureId\"}],\"name\":\"\"}],\"id\":\"sample-contract\",\"name\":\"Test Document\"}],\"status\":\"SENT\",\"type\":\"PACKAGE\",\"roles\":[{\"id\":\"Signer1\",\"reassign\":true,\"type\":\"SIGNER\",\"signers\":[{\"email\":\"mail32@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"id\":\"Signer1\"}],\"name\":\"Signer1\"}],\"name\":\"Change Signer Example\"}";
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            //First document
            byte[] fileByteArray = File.ReadAllBytes(@"C:/Users/hhaidary/Desktop/PDFs/doc1.pdf");
            ByteArrayContent content1 = new ByteArrayContent(fileByteArray);

            content1.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content1.Headers.ContentDisposition.Name = "\"file\"";
            content1.Headers.ContentDisposition.FileName = "\"sample_contract.pdf\"";
            content1.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            //Multipart form-data
            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content1, "\"file\"", "\"sample_contract.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", Properties.Settings.Default.key);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri("https://sandbox.esignlive.com/api") + "/packages/", form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
